> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/instance/placement-group/modifyinstanceplacement.md).

# ModifyInstancePlacement

## 1. API Description

This API (ModifyInstancePlacement) is used to add an instance to a placement group, migrate it from one placement group to another, or remove it from a placement group.

{% hint style="info" %}
**Precautions**

* When `placementGroupId` is empty, it indicates removing the instance from the current placement group.
* When `placementGroupId` is not empty, it indicates adding the instance to the specified placement group; if the instance is already in another placement group, it will be removed from the original placement group and then added to the new one (i.e., migration).
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name   | Required | Type   | Description                                                                                                                                                                                                                                                         |
| ---------------- | -------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceId       | Yes      | String | <p>Instance ID.</p><p>It can be obtained by calling <a href="/api-reference/zec/instance/describeinstances.md">DescribeInstances</a>.</p>                                                                                                                           |
| placementGroupId | No       | String | <p>Placement group ID.</p><p>An empty value indicates removing the instance from the current placement group.</p><p>It can be obtained by calling <a href="/api-reference/zec/instance/placement-group/describeplacementgroups.md">DescribePlacementGroups</a>.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Add an instance to a placement group (or migrate it from another placement group to this one).**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstancePlacement
<Common Request Params>

Request：
{
  "instanceId": "instance-xxxxxxxx",
  "placementGroupId": "placementgroup-yyyyyyyy"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

**2. Remove the instance from its current placement group.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstancePlacement
<Common Request Params>

Request：
{
  "instanceId": "instance-xxxxxxxx"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                                  | Description                                                                                                     |
| ---------------- | ----------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                               | Instance not found.                                                                                             |
| 404              | INVALID\_PLACEMENT\_GROUP\_NOT\_FOUND                       | The placement group does not exist.                                                                             |
| 400              | INVALID\_PLACEMENT\_GROUP\_AND\_INSTANCE\_ZONE\_MISMATCHED  | The available zones for the instance and the placement group do not match.                                      |
| 400              | INVALID\_LIMIT\_EXCEEDED\_PLACEMENT\_GROUP\_INSTANCE\_COUNT | The number of instances in the placement group has reached the partition limit. No more instances can be added. |
